<script lang="ts" setup>
import { usePromotionStore } from '@/stores/Promotion'
import { computed, ref, watch } from 'vue'

const promotionStore = usePromotionStore()
const selectedDate = ref()
const showDatePicker = ref(false)
// ถ้าเป็นedit เอาค่ามาใส่ด้วย
if (promotionStore.editedPromotion.id! > -1) {
  selectedDate.value = parseDateDMY(promotionStore.editedPromotion.enddate)
}
// แปลงคืน
function parseDateDMY(dateString: any) {
  const parts = dateString.split('-')
  const day = parseInt(parts[0], 10)
  const month = parseInt(parts[1], 10) - 1 // Months are zero-based in JavaScript
  const year = parseInt(parts[2], 10) + 2000 // Assuming the year is 2-digit representation

  return new Date(year, month, day)
}
// แปลงไป
const formattedDate = computed(() => {
  if (!selectedDate.value) return null
  const date = new Date(selectedDate.value)
  const year = date.getFullYear()
  const month = (date.getMonth() + 1).toString().padStart(2, '0')
  const day = date.getDate().toString().padStart(2, '0')

  return `${day}-${month}-${year}`
})

// ถ้าformattedDate มีการเปลี่ยงแปลง ให้เซ็ตค่า editedpromotion ทุกครั้ง
watch(formattedDate, (newValue) => {
  if (newValue !== null) {
    promotionStore.editedPromotion.enddate = newValue
  }
})
//เมื่อเลือกdatepicker ให้ setค่า selectdate
const updateSelectedDate = (newValue: any) => {
  selectedDate.value = newValue
}
// เปิดปิด datepicker
const toggleDatePicker = () => {
  showDatePicker.value = !showDatePicker.value
}
</script>
<template>
  <v-text-field
    v-model="formattedDate"
    :readonly="true"
    :rules="[(v) => !!v || 'Field is required']"
    append-inner-icon="mdi-calendar"
    @click="toggleDatePicker"
    label="Start date"
  ></v-text-field>
  <v-date-picker
    class="small-datepicker"
    v-model="selectedDate"
    @input="updateSelectedDate"
    format="yyyy-MM-dd"
    locale="en"
    color="#784424"
    v-show="showDatePicker"
  />
</template>
